import java.awt.*;
import java.applet.*;
public class worldTest
{
    /*________________________________
    ___________Variable_____________*/
    //functor
    pigFunc pig = new pigFunc();
    //worldFunc w = new worldFunc();
    //springFunc s = new springFunc();
    //atomFunc a = new atomFunc();
    //constant
    int maxAtoms = 500;                             // max atom allowed
    double deltaT = 0.001d;                         // physics frame lenght
    
    world U = new world(maxAtoms, new vector(400,70), new vector(340,450));
    spring sprLst;

    /*________________________________
    ___________Initialisation_______*/
    public void initialize() 
    {
        U.append(new atom(650, 250, 5, 12));         // spawn the square spring
        U.append(new atom(680, 290, 5, 12));
        U.append(new atom(680, 250, 5, 12));
        U.append(new atom(650, 290, 5, 12));
        
        U.append(new atom(580, 250, 5, 12));         // spawn the square spring
        U.append(new atom(610, 290, 5, 12));
        U.append(new atom(610, 250, 5, 12));
        U.append(new atom(580, 290, 5, 12));
        U.append(new atom(530, 270, 5, 12));         // spawn the square spring
        U.append(new atom(530, 290, 5, 12));
        U.append(new atom(550, 290, 5, 12));
        U.append(new atom(550, 270, 5, 12));
        
        for (int i=0;i<5;i++)                       // atom fountain machine 
        {
            U.append(new atom(760, 82, 6, 12));
        }
        for (int i=5;i<8;i++)
        {
            U.append(new atom(600, 80, 8, 15));
        }
        for (int i=8;i<15;i++)
        {
            U.append(new atom(530, 20, 52, 16));
        }
        for (int i=15;i<maxAtoms;i++)
        {
            U.append(new atom(640, 440, 2, 8));
        }
                                                                // make some springs; hardcoded
        
        sprLst = new spring(0,1,U.atomLst[0].distanceCenters(U.atomLst[1]));
        sprLst.insert(new spring(2,3,U.atomLst[2].distanceCenters(U.atomLst[3])));
        sprLst.insert(new spring(1,2,U.atomLst[1].distanceCenters(U.atomLst[2])));
        sprLst.insert(new spring(3,1,U.atomLst[3].distanceCenters(U.atomLst[1])));
        sprLst.insert(new spring(2,0,U.atomLst[2].distanceCenters(U.atomLst[0])));
        sprLst.insert(new spring(3,0,U.atomLst[3].distanceCenters(U.atomLst[0])));
        
       // sprLst = s.insert(sprLst, new spring(3,4,a.distanceCenters(U.atomLst[3], U.atomLst[4])));
        //sprLst = s.insert(sprLst, new spring(2,5,a.distanceCenters(U.atomLst[2], U.atomLst[5])));
       // sprLst = s.insert(sprLst, new spring(3,5,a.distanceCenters(U.atomLst[3], U.atomLst[5])));
       // sprLst = s.insert(sprLst, new spring(2,4,a.distanceCenters(U.atomLst[2], U.atomLst[4])));
 
        sprLst.insert(new spring(4,5,U.atomLst[4].distanceCenters( U.atomLst[5])));
        sprLst.insert(new spring(6,7,U.atomLst[6].distanceCenters( U.atomLst[7])));
        sprLst.insert(new spring(5,6,U.atomLst[5].distanceCenters( U.atomLst[6])));
        sprLst.insert(new spring(7,5,U.atomLst[7].distanceCenters( U.atomLst[5])));
        sprLst.insert(new spring(6,4,U.atomLst[6].distanceCenters( U.atomLst[4])));
        sprLst.insert(new spring(7,4,U.atomLst[7].distanceCenters( U.atomLst[4])));
        
        sprLst.insert(new spring(8,7,U.atomLst[8].distanceCenters(U.atomLst[7])));
        sprLst.insert(new spring(9,7,U.atomLst[9].distanceCenters(U.atomLst[7])));
        sprLst.insert(new spring(9,6,U.atomLst[9].distanceCenters(U.atomLst[6])));
        sprLst.insert(new spring(8,9,U.atomLst[8].distanceCenters(U.atomLst[9])));
        
        //new spring struct
//        
//        U.atomLst[0].linkWith(1,U.atomLst[0].distanceCenters( U.atomLst[1]));
//        U.atomLst[1].linkWith(0,U.atomLst[0].distanceCenters( U.atomLst[1]));
//        U.atomLst[2].linkWith(3,U.atomLst[2].distanceCenters( U.atomLst[3]));
//        U.atomLst[3].linkWith(2,U.atomLst[2].distanceCenters( U.atomLst[3]));
//        U.atomLst[1].linkWith(2,U.atomLst[1].distanceCenters( U.atomLst[2]));
//        U.atomLst[3].linkWith(1,U.atomLst[3].distanceCenters( U.atomLst[1]));
//        U.atomLst[2].linkWith(0,U.atomLst[2].distanceCenters( U.atomLst[0]));
//        U.atomLst[3].linkWith(0,U.atomLst[3].distanceCenters( U.atomLst[0]));
//        U.atomLst[2].linkWith(1,U.atomLst[1].distanceCenters( U.atomLst[2]));
//        U.atomLst[1].linkWith(3,U.atomLst[3].distanceCenters( U.atomLst[1]));
//        U.atomLst[0].linkWith(2,U.atomLst[2].distanceCenters( U.atomLst[0]));
//        U.atomLst[0].linkWith(3,U.atomLst[3].distanceCenters( U.atomLst[0]));
//        
//        U.atomLst[4].linkWith(5,U.atomLst[4].distanceCenters(U.atomLst[5]));
//        U.atomLst[6].linkWith(7,U.atomLst[6].distanceCenters(U.atomLst[7]));
//        U.atomLst[5].linkWith(6,U.atomLst[5].distanceCenters(U.atomLst[6]));
//        U.atomLst[7].linkWith(5,U.atomLst[7].distanceCenters(U.atomLst[5]));
//        U.atomLst[6].linkWith(4,U.atomLst[6].distanceCenters(U.atomLst[4]));
//        U.atomLst[7].linkWith(4,U.atomLst[7].distanceCenters(U.atomLst[4]));

//        U.atomLst[5].linkWith(4,U.atomLst[4].distanceCenters(U.atomLst[5]));
//        U.atomLst[7].linkWith(6,U.atomLst[6].distanceCenters(U.atomLst[7]));
//        U.atomLst[6].linkWith(5,U.atomLst[5].distanceCenters(U.atomLst[6]));
//        U.atomLst[5].linkWith(7,U.atomLst[7].distanceCenters(U.atomLst[5]));
//        U.atomLst[4].linkWith(6,U.atomLst[6].distanceCenters(U.atomLst[4]));
//        U.atomLst[4].linkWith(7,U.atomLst[7].distanceCenters(U.atomLst[4]));
//        
//        U.atomLst[8].linkWith(7,U.atomLst[8].distanceCenters(U.atomLst[7]));
//        U.atomLst[9].linkWith(7,U.atomLst[9].distanceCenters(U.atomLst[7]));
//        U.atomLst[9].linkWith(6,U.atomLst[9].distanceCenters(U.atomLst[6]));
//        U.atomLst[8].linkWith(9,U.atomLst[8].distanceCenters(U.atomLst[9]));

//        U.atomLst[7].linkWith(8,U.atomLst[8].distanceCenters(U.atomLst[7]));
//        U.atomLst[7].linkWith(9,U.atomLst[9].distanceCenters(U.atomLst[7]));
//        U.atomLst[6].linkWith(9,U.atomLst[9].distanceCenters(U.atomLst[6]));
//        U.atomLst[9].linkWith(8,U.atomLst[8].distanceCenters(U.atomLst[9]));
   
    }
    /*________________________________
    ___________Main Loop____________*/
    public void loop()
    {
            //reset forces
            U.resetForce();

            //spring forces
            sprLst.iterateForce(U.atomLst, U.atomQty);
//            for (int i=0; i< U.atomQty; i++)
//                U.atomLst[i].springForce(U.atomLst);

            //atom forces
            U.interAtomCollisionResponse();
         
            //world forces
            U.environmentalForce();
   
            //integrate
            U.integrate(deltaT);
   
            //hardcollision
            //termnialvelocity
            //velocitydrag
            U.boxCollisionDetectionResponse();
    }
    
    /*________________________________
    ___________draw_________________*/
    public void paint (Graphics g) 
    {
        //draw something
        g.setColor(Color.black);
        g.drawLine(400,60,500,60);
        g.drawString("World Test",502,64);

        for (int i=0; i<maxAtoms; i++)
        {
            if (U.atomLst[i].rested == true)                // if rested, draw red
            {
                g.setColor(Color.red);
                pig.circle(g, U.atomLst[i].pos, U.atomLst[i].radius);
            }
            else                                            // if moving, draw blue
            {
                g.setColor(Color.blue);
                pig.circle(g, U.atomLst[i].pos, U.atomLst[i].radius);
            }
        }
        
        g.setColor(Color.green);
        spring tmpSpr = sprLst;
        do{
            pig.line(g, U.atomLst[tmpSpr.i].pos, U.atomLst[tmpSpr.j].pos);
            tmpSpr = tmpSpr.next();
        }while(tmpSpr != null);
        
        g.setColor(Color.blue);
        pig.rect(g, U.boxPos, U.boxSize);
    }
}
