import static java.lang.Math.*;
public class spring{
    /*propertie
    _________________________________________*/
    int i,              // atom from one end
        j;              // atom on the other end
     double breaklimit;     // breaks if force over
     double rigidity;       // rigidity factor for iteration purposes
     double lenght;         // lenght when created (resting lenght)
     spring next,
            back;
           
    static vectorFunc v = new vectorFunc();;
    /*constructor
    __________________________________________*/
    public spring(int _i, int _j, double l)
    {
        i = _i;
        j = _j;
        breaklimit = 30000;
        rigidity = 30;
        lenght = l;
        next = null;
        back = null;
    }

    public spring(int _i, int _j)
    {
        i = _i;
        j = _j;
        breaklimit = 30000;
        rigidity = 30;
        lenght = 10;
        next = null;
        back = null;
    }
    
    public spring(spring s)
    {
        i = s.i;
        j = s.j;
        breaklimit = s.breaklimit;
        rigidity = s.rigidity;
        lenght = s.lenght;
        next = null;
        back = null;
    }
    /*method
    ________________________________________*/
    
    
    public vector springForces(atom[] atomLst)    // return self repulsion spring+damper forces
    {
       ///boolean istate = a.getrest(atomLst[s.i]);                 //restingcode get resting state for both atoms
       ///boolean jstate = a.getrest(atomLst[s.j]);                 //restingcode
       ///if (istate == false || jstate == false)                   //restingcode if one of them is active do the springness (should unrest other atom that is true)
       {
        double distCenters = sqrt(atomLst[i].distanceCentersSQ(atomLst[j]));  // returns SQdistance of atoms centers, 
        if (distCenters == 0)
        {
            distCenters = 0.1d;                     // case distance = 0, make it work. (could delete spring too or break)
        }
        vector link = v.sub(atomLst[i].pos, atomLst[j].pos);                // get vector between i and j
        double mult =  (distCenters - lenght)*-25000;                         // get force multiple: -K*( dist(i,j) - spring.lenght)
        double comp = (atomLst[i].mass*atomLst[j].mass)/(atomLst[i].mass+atomLst[j].mass);      // get mass compensation
        
        vector spring = v.scale(v.sub(v.scale(link, mult), link), comp*0.7);      // calculate spring forces
        vector damper = v.scale((v.sub(atomLst[j].vel, atomLst[i].vel)), comp*50);                   // D=damping  (semi broken) 
     
        return v.add(spring, damper);
       }
       ///else return new vector();                             //restingcode if both atom rested, return nothing
    }
    
    //usage
    //springLst = s.insert(springLst, nuspring
    //return new updated spring list
    public void insert(spring nuspring)
    {
        nuspring.next = next;
        next = nuspring;
        nuspring.back = this;
        
    }
    
    //usage in world
    //atomLst = iterate(springLst, atomLst)
    //return new updated atom list
    public void iterateForce(atom [] atomLst, int atomQty)
    {
        //here is the function
        vector tmpForce = springForces(atomLst);
        atomLst[i].addforce(tmpForce);
        atomLst[j].subforce(tmpForce);
        //not sure what to do about breakage
        //but cant be done here
        //this is recursive loop... trolololo
        if (next != null)
            next.iterateForce(atomLst, atomQty);
        //return the list
    }
    
    //usage
    //springLst = pete(springToPete)
    //list will be null if none left
    public void pete(spring sprCur)
    {
        // double linked list
        // a <=> b <=> c
        // remove b
        // a->next = b-> next :::: while a =  b->back, then b->back->next = b->next
        // something alike with c
        // a <=> c
        if (next != null)
            next.back = back;
        if (back != null)
            back.next = next;
    }
    
    //simple iterator
    //usage
    //sprLoop = next(sprLoop);
    public spring next()
    {
        return next;
    }
}
